var __play68_temp_sdk_obj = function () {
    var e = null;
    var t = null;
    if (typeof window.PLAY68_APP !== "undefined") {
        e = "android"
    } else if (typeof window.webkit !== "undefined") {
        e = "ios"
    } else if (typeof window.jsb !== "undefined") {
        e = "cocos";
        t = window.jsb.reflection.callStaticMethod
    }

    function a() {
        var e = Array.prototype.slice.apply(arguments);
        e.unshift(">>>SDK_DEBUG: ");
        console.log(e.toString())
    }

    function n(e, t) {
        return new Array(t + 1).join(e)
    }

    function i() {
        return e === "android"
    }

    function r() {
        return e === "cocos"
    }

    function o() {
        return e === "ios"
    }

    function s() {
        if (typeof cc !== "undefined") {
            return cc.sys && cc.sys.os === cc.sys.OS_IOS
        }
        return false
    }
    var c = "com/potatoplay/play68appsdk/Play68SdkCocos";
    var f = "Ljava/lang/String;";
    var l = "RootViewController";
    var d = "js2Native:";
    if (s()) {
        u("cocos_init")
    }

    function u() {
        if (!e) {
            console.error("require app env");
            return
        }
        if (arguments.length < 1) {
            console.error("require arguments");
            return
        }
        var a = Array.prototype.slice.apply(arguments);
        var u = JSON.stringify(a);
        if (i()) {
            var h = arguments[0];
            if (!window.PLAY68_APP.hasOwnProperty(h)) {
                console.error("method not exists: " + h);
                return
            }
            window.PLAY68_APP[h].apply(window.PLAY68_APP, a.slice(1))
        } else if (o()) {
            if (typeof window.webkit.messageHandlers.sdkHandler !== "undefined") {
                window.webkit.messageHandlers.sdkHandler.postMessage(u)
            }
        } else if (r()) {
            if (s()) {
                t.apply(t, [l, d, u])
            } else {
                t.apply(t, [c, arguments[0], "(" + n(f, arguments.length - 1) + ")V"].concat(a.slice(1)))
            }
        }
    }

    function h(a) {
        if (!e) {
            console.error("require app env");
            return null
        }
        if (i()) {
            if (!window.PLAY68_APP.hasOwnProperty(a)) {
                console.error("method not exists: " + a);
                return
            }
            return window.PLAY68_APP[a].call(window.PLAY68_APP)
        } else if (o()) {
            return localStorage.getItem(a)
        } else if (r()) {
            if (s()) {
                return cc.sys.localStorage.getItem(a)
            } else {
                return t(c, a, "()" + f)
            }
        }
    }

    function p() {
        if (!e) {
            console.error("require app env");
            return null
        }
        if (arguments.length < 1) {
            console.error("require arguments");
            return null
        }
        var t = Array.prototype.slice.apply(arguments);
        var a = arguments[0];
        if (i()) {
            if (!window.PLAY68_APP.hasOwnProperty(a)) {
                console.error("method not exists" + a);
                return
            }
            return window.PLAY68_APP[a].apply(window.PLAY68_APP, t.slice(1))
        } else if (o()) {
            return window.prompt(a, t.slice(1).join("#:#"))
        }
        return null
    }

    function y(e) {
        this.name = e
    }

    function g(e, t) {
        this.name = e;
        this.cbName = t
    }

    function v(e, t) {
        this.code = t || -1;
        this.message = e;
        a("PLAY68_Error", this.code, this.message)
    }
    var A = {
        "-99": "未播放的广告对象超过限制",
        "-22": "admob未初始化",
        "-7": "banner未显示，隐藏失败。",
        "-6": "传入的广告对象错误",
        "-5": "传入的广告对象不存在或未成功加载",
        "-4": "传入的广告ID为空",
        "-3": "广告初始化请求太频繁，建议请求间隔3秒以上。",
        "-2": "未初始化广告，无法显示。",
        "-1": "用户强制关闭广告。",
        0: "内部发生了一些事情；例如，从广告服务器收到无效响应。",
        1: "广告请求无效；例如，广告单元ID不正确。",
        2: "由于网络连接，广告请求未成功。",
        3: "广告请求已成功，但由于缺少广告资源，因此未返回任何广告。",
        9: "No ad to show from all configured ad networks."
    };

    function m(e) {
        var t = A.hasOwnProperty(e) ? A[e] : "adMessages未定义错误";
        return new v(t, e)
    }
    var b = {
        "-4": "订阅ID与商品ID不能混合。",
        "-3": "商品ID未找到。",
        "-2": "当前设备上的Play商店不支持请求的功能。",
        "-1": "Play Store服务现在没有连接 - 可能是暂时状态。",
        0: "OK",
        1: "用户按下或取消了对话框",
        2: "网络连接中断",
        3: "请求的类型不支持结算API版本",
        4: "请求的产品无法购买",
        5: "提供给API的参数无效。",
        6: "API操作期间发生致命错误",
        7: "由于物品已经拥有，因此未能购买",
        8: "由于物品未拥有，因此未能消费"
    };

    function C(e) {
        var t = b.hasOwnProperty(e) ? b[e] : "payMessages未定义错误";
        return new v(t, e)
    }

    function k(e) {
        return typeof e === "function"
    }

    function I() {
        if (arguments.length < 1) {
            return
        }
        var e = Array.prototype.slice.apply(arguments);
        var t = arguments[0];
        k(t) && t.apply(t, e.slice(1))
    }

    function S(e, t) {
        return (e ? e : "") + (t ? ":" + t : "")
    }

    function w(e) {
        e = e || (new Date).getTime();
        return e + "_" + Math.random()
    }

    function P() {
        this.ERROR = "error";
        this.LOADED = "loaded";
        this.OPENED = "opened";
        this.CLICKED = "clicked";
        this.CLOSED = "closed";
        this.DISPLAYED = "displayed";
        this.HIDDEN = "hidden";
        this.INTERSTITIAL = "interstitial";
        this.REWARDED_VIDEO = "rewarded_video";
        this.BANNER = "banner";
        this.LAST_INTERSTITIAL = 0;
        this.LAST_REWARDED_VIDEO = 0;
        this.timeStep = 3e3;
        this.SdkCallbackStore = {};
        this.player = {
            id: "",
            photo: "",
            name: ""
        };
        this.playerLogin = false;
        this.dataUrl = "https://sdk.fb.h5haha.com/data";
        this.fbFriendUrl = "";
        this.defaultPhoto = "https://sdk.fb.h5haha.com/static/images/default_photo.jpg";
        this.dataPlatform = o() || s() ? "ios" : "android";
        this.appId = "";
        this.leaderBoardName = "leaderBoard";
        this.isCocos = r;
        this.isAndroid = i
    }
    P.prototype = {
        SdkCallback: function (e, t) {
            if (!e) {
                return
            }
            a("SdkCallback", e, t);
            if (this.SdkCallbackStore[e]) {
                if (t) {
                    try {
                        t = JSON.parse(t)
                    } catch (e) {
                        t = null;
                        alert("SdkCallback Error: " + e.message + " : " + t);
                        a("SdkCallback Error: " + e.message + " : " + t)
                    }
                } else {
                    t = null
                }
                this.SdkCallbackStore[e](t);
                this.removeCallback(e)
            }
        },
        addCallback: function (e, t) {
            this.SdkCallbackStore[e] = t
        },
        removeCallback: function (e) {
            delete this.SdkCallbackStore[e]
        },
        exception: function (e, t) {
            if (!t) {
                switch (e) {
                    case -1:
                        t = "require fb env";
                        break;
                    case -2:
                        t = "api error";
                        break;
                    case -3:
                        t = "player id error";
                        break;
                    case -4:
                        t = "object error";
                        break;
                    default:
                        t = "unknown error"
                }
            }
            return {
                code: e,
                message: t
            }
        },
        postData: function (e, t, a, n, i) {
            n = n || "text";
            i = i || true;
            var r = this.getUrlParam(t);
            var o = new XMLHttpRequest;
            o.open("POST", e, i);
            o.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            o.setRequestHeader("X-Requested-With", "XMLHttpRequest");
            o.send(r);
            var s = function () {
                if (!k(a)) return false;
                if (o.readyState === 4 && o.status === 200) {
                    if (n === "json" || n === "JSON") {
                        var e = null;
                        try {
                            e = JSON.parse(o.responseText)
                        } catch (t) {
                            e = null
                        }
                        a(e)
                    } else if (n === "xml" || n === "XML") {
                        a(o.responseXML)
                    } else {
                        a(o.responseText)
                    }
                }
            };
            if (i) {
                o.onreadystatechange = s
            } else {
                s()
            }
        },
        getUrlParam: function (e) {
            var t = [];
            for (var a in e) {
                if (e.hasOwnProperty(a)) {
                    var n = e[a];
                    if (typeof n === "string") {
                        n = n.replace(/&/g, "%26")
                    }
                    t[t.length] = a + "=" + n
                }
            }
            return t.join("&").replace(/\+/g, "%2B").replace(/"/g, "%22").replace(/'/g, "%27").replace(/\//g, "%2F")
        },
        init: function (e) {
            this.getPlayerInfo();
            if (!this.playerLogin) {
                this.startLogin(e);
                return
            }
            I(e, true, this.player)
        },
        initSdk: function (e) {
            this.init(e)
        },
        start: function (e) {
            I(e, true, this.player)
        },
        startGame: function (e) {
            this.start(e)
        },
        setLoadingProgress: function (e) {
            if (e >= 100) {
                u("finishProgressBar")
            }
        },
        getEntryPointData: function () {
            var e = h("getEntryPointData");
            var t = {};
            try {
                t = e === "" ? {} : JSON.parse(e)
            } catch (e) {
                t = {}
            }
            return t
        },
        getPlayerInfo: function () {
            if (this.player.id === "") {
                var e = h("getUserInfo");
                var t = null;
                try {
                    t = JSON.parse(e)
                } catch (e) {
                    t = null
                }
                t && (this.player = t)
            }
            return this.player
        },
        getContextInfo: function () {
            return {
                id: null,
                type: "SOLO"
            }
        },
        getSignedPlayerInfoAsync: function (e) {
            var t = h("getUserSign");
            k(e) && e({
                id: this.player.id,
                signature: t
            })
        },
        startLogin: function (e) {
            var t = this;
            var a = "startLogin";
            this.addCallback(a, function (a) {
                if (a.code === 0) {
                    t.playerLogin = true;
                    if (a.data && a.data.photo === "") {
                        a.data.photo = t.defaultPhoto
                    }
                    t.player = a.data;
                    I(e, true, t.player)
                } else {
                    I(e, false, new v("login error", a.code))
                }
            });
            u(a, a)
        },
        getDataAsync: function (e, t) {
            var a = this;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            a.postData(a.dataUrl + "/get-data", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                keys: JSON.stringify(e)
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        getData: function (e, t) {
            this.getDataAsync(e, function (e, a) {
                if (e) {
                    k(t) && t(a)
                }
            })
        },
        setDataAsync: function (e, t) {
            var a = this;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            this.postData(a.dataUrl + "/set-data", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                data: JSON.stringify(e)
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        setData: function (e, t) {
            this.setDataAsync(e, function (e, a) {
                if (e) {
                    k(t) && t(a)
                }
            })
        },
        getStatsAsync: function (e, t) {
            var a = this;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            a.postData(a.dataUrl + "/get-stats", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                keys: JSON.stringify(e)
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        setStatsAsync: function (e, t) {
            var a = this;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            this.postData(a.dataUrl + "/set-stats", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                data: JSON.stringify(e)
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        incrementStatsAsync: function (e, t) {
            var a = this;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            this.postData(a.dataUrl + "/increment-stats", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                data: JSON.stringify(e)
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        getLeaderBoardInfoV2: function (e, t) {
            var a = this;
            e = e || a.leaderBoardName;
            k(t) && t(true, {
                name: e,
                contextId: null,
                entryCount: 99
            })
        },
        getLeaderBoardInfo: function (e, t) {
            this.getLeaderBoardInfoV2(e, function (e, a) {
                if (e) {
                    k(t) && t(a)
                }
            })
        },
        setScoreAsyncV2: function (e, t, a, n) {
            var i = this;
            a = a || "";
            e = e || i.leaderBoardName;
            if (!i.player.id || !i.appId) {
                k(n) && n(false, i.exception(-3));
                return
            }
            this.postData(i.dataUrl + "/set-score", {
                platform: i.dataPlatform,
                app_id: i.appId,
                uid: i.player.id,
                name: e,
                score: t,
                extra_data: a,
                user_info: JSON.stringify(i.player)
            }, function (e) {
                if (e && e.code === 0) {
                    k(n) && n(true, e.data)
                } else if (e) {
                    k(n) && n(false, i.exception(e.code, e.data))
                } else {
                    k(n) && n(false, i.exception(-2))
                }
            }, "json")
        },
        setScoreAsync: function (e, t, a, n) {
            this.setScoreAsyncV2(e, t, a, function (e, t) {
                if (e) {
                    k(n) && n(t)
                }
            })
        },
        getPlayerEntryAsyncV2: function (e, t) {
            var a = this;
            e = e || a.leaderBoardName;
            if (!a.player.id || !a.appId) {
                k(t) && t(false, a.exception(-3));
                return
            }
            this.postData(a.dataUrl + "/get-entry", {
                platform: a.dataPlatform,
                app_id: a.appId,
                uid: a.player.id,
                name: e
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        getPlayerEntryAsync: function (e, t) {
            this.getPlayerEntryAsyncV2(e, function (e, a) {
                if (e) {
                    k(t) && t(a)
                }
            })
        },
        getEntriesAsyncV2: function (e, t, a, n) {
            var i = this;
            t = t || 10;
            a = a || 0;
            e = e || i.leaderBoardName;
            if (!i.player.id || !i.appId) {
                k(n) && n(false, i.exception(-3));
                return
            }
            this.postData(i.dataUrl + "/get-entries", {
                platform: i.dataPlatform,
                app_id: i.appId,
                name: e,
                count: t,
                offset: a
            }, function (e) {
                if (e && e.code === 0) {
                    k(n) && n(true, e.data)
                } else if (e) {
                    k(n) && n(false, i.exception(e.code, e.data))
                } else {
                    k(n) && n(false, i.exception(-2))
                }
            }, "json")
        },
        getEntriesAsync: function (e, t, a, n) {
            this.getEntriesAsyncV2(e, t, a, function (e, t) {
                if (e) {
                    k(n) && n(t)
                }
            })
        },
        getConnectedPlayerEntriesAsyncV2: function (e, t, a, n) {
            var i = this;
            t = t || 10;
            a = a || 0;
            e = e || i.leaderBoardName;
            if (!i.player.id || !i.appId) {
                k(n) && n(false, i.exception(-3));
                return
            }
            this.postData(i.dataUrl + "/get-entries", {
                platform: i.dataPlatform,
                app_id: i.appId,
                name: e,
                count: t,
                offset: a
            }, function (e) {
                if (e && e.code === 0) {
                    k(n) && n(true, e.data)
                } else if (e) {
                    k(n) && n(false, i.exception(e.code, e.data))
                } else {
                    k(n) && n(false, i.exception(-2))
                }
            }, "json")
        },
        getConnectedPlayerEntriesAsync: function (e, t, a, n) {
            this.getConnectedPlayerEntriesAsyncV2(e, t, a, function (e, t) {
                if (e) {
                    k(n) && n(t)
                }
            })
        },
        isSupportAd: function () {
            return !(h("isSupportAd") === "")
        },
        __timestamp: function () {
            return Math.round((new Date).getTime() / 1e3)
        },
        __isToFast: function (e, t) {
            t = t || 3;
            if (e > 0) {
                return this.__timestamp() - e < t
            }
            return false
        },
        getInterstitialAd: function (e, t) {
            if (this.__isToFast(this.LAST_INTERSTITIAL)) {
                return
            }
            this.LAST_INTERSTITIAL = this.__timestamp();
            this.getInterstitialAdAsync(e, function (e) {
                if (e) {
                    I(t, true, null)
                }
            })
        },
        showInterstitialAd: function (e, t) {
            this.showAsync(new y(this.INTERSTITIAL), function (e) {
                if (e) {
                    I(t, true, null)
                }
            })
        },
        getRewardedVideo: function (e, t) {
            if (this.__isToFast(this.LAST_REWARDED_VIDEO)) {
                return
            }
            this.LAST_REWARDED_VIDEO = this.__timestamp();
            this.getRewardedVideoAsync(e, function (e) {
                if (e) {
                    I(t, true, null)
                }
            })
        },
        showRewardedVideo: function (e, t) {
            this.showAsync(new y(this.REWARDED_VIDEO), function (e) {
                if (e) {
                    I(t, true, null)
                }
            })
        },
        getInterstitialAdAsync: function (e, t) {
            var a = this;
            var n = this.INTERSTITIAL;
            if (this.__isToFast(this.LAST_INTERSTITIAL)) {
                setTimeout(function () {
                    I(t, false, m(-3))
                }, this.timeStep);
                return
            }
            this.LAST_INTERSTITIAL = this.__timestamp();
            var i = S(n, this.LOADED);
            var r = S(n, this.ERROR);
            var o = function () {
                a.removeCallback(i);
                a.removeCallback(r)
            };
            this.addCallback(i, function () {
                o();
                I(t, true, new y(n))
            });
            this.addCallback(r, function (e) {
                o();
                I(t, false, m(e.code))
            });
            u("getInterstitialAdAsync", e)
        },
        getRewardedVideoAsync: function (e, t) {
            var a = this;
            var n = this.REWARDED_VIDEO;
            if (this.__isToFast(this.LAST_REWARDED_VIDEO)) {
                setTimeout(function () {
                    I(t, false, m(-3))
                }, this.timeStep);
                return
            }
            this.LAST_REWARDED_VIDEO = this.__timestamp();
            var i = S(n, this.LOADED);
            var r = S(n, this.ERROR);
            var o = function () {
                a.removeCallback(i);
                a.removeCallback(r)
            };
            this.addCallback(i, function () {
                o();
                I(t, true, new y(n))
            });
            this.addCallback(r, function (e) {
                o();
                I(t, false, m(e.code))
            });
            u("getRewardedVideoAsync", e)
        },
        showAsync: function (e, t) {
            if (!(e instanceof y)) {
                var a = m(-6);
                I(t, false, a);
                console.error(a.message);
                return
            }
            var n = this;
            var i = e.name;
            var r = S(i, this.CLOSED);
            var o = S(i, this.ERROR);
            var s = function () {
                n.removeCallback(r);
                n.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, new y(i))
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("showAsync", i)
        },
        getBannerAsync: function (e, t) {
            var a = this;
            var n = this.BANNER;
            var i = S(n, this.LOADED);
            var r = S(n, this.ERROR);
            var o = function () {
                a.removeCallback(i);
                a.removeCallback(r)
            };
            this.addCallback(i, function () {
                o();
                I(t, true, new y(n))
            });
            this.addCallback(r, function (e) {
                o();
                I(t, false, m(e.code))
            });
            u("getBannerAsync", e)
        },
        closeBannerAsync: function () {
            u("closeBannerAsync")
        },
        getInterstitialAdAsyncV3: function (e, t) {
            var a = this;
            var n = this.INTERSTITIAL;
            var i = w(this.INTERSTITIAL);
            if (this.__isToFast(this.LAST_INTERSTITIAL)) {
                setTimeout(function () {
                    I(t, false, m(-3))
                }, this.timeStep);
                return
            }
            this.LAST_INTERSTITIAL = this.__timestamp();
            var r = S(i, this.LOADED);
            var o = S(i, this.ERROR);
            var s = function () {
                a.removeCallback(r);
                a.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, new g(n, i))
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("getInterstitialAdAsyncV3", i, e)
        },
        getRewardedVideoAsyncV3: function (e, t) {
            var a = this;
            var n = this.REWARDED_VIDEO;
            var i = w(this.REWARDED_VIDEO);
            if (this.__isToFast(this.LAST_REWARDED_VIDEO)) {
                setTimeout(function () {
                    I(t, false, m(-3))
                }, this.timeStep);
                return
            }
            this.LAST_REWARDED_VIDEO = this.__timestamp();
            var r = S(i, this.LOADED);
            var o = S(i, this.ERROR);
            var s = function () {
                a.removeCallback(r);
                a.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, new g(n, i))
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("getRewardedVideoAsyncV3", i, e)
        },
        showAsyncV3: function (e, t) {
            if (!(e instanceof g)) {
                var a = m(-6);
                I(t, false, a);
                console.error(a.message);
                return
            }
            var n = this;
            var i = e.name;
            var r = e.cbName;
            var o = S(r, this.CLOSED);
            var s = S(r, this.ERROR);
            var c = function () {
                n.removeCallback(o);
                n.removeCallback(s)
            };
            this.addCallback(o, function () {
                c();
                I(t, true, e)
            });
            this.addCallback(s, function (e) {
                c();
                I(t, false, m(e.code))
            });
            u("showAsyncV3", r, i)
        },
        getBannerAsyncV3: function (e, t) {
            var a = this;
            var n = this.BANNER;
            var i = w(this.BANNER);
            var r = S(i, this.LOADED);
            var o = S(i, this.ERROR);
            var s = function () {
                a.removeCallback(r);
                a.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, new g(n, i))
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("getBannerAsyncV3", i, e)
        },
        showBannerAsyncV3: function (e, t, a) {
            if (!(e instanceof g)) {
                var n = m(-6);
                I(t, false, n);
                console.error(n.message);
                return
            }
            var i = this;
            var r = e.cbName;
            var o = S(r, this.OPENED);
            var s = S(r, this.ERROR);
            var c = function () {
                i.removeCallback(o);
                i.removeCallback(s)
            };
            a = a || "portrait:bottom:0";
            this.addCallback(o, function () {
                c();
                I(t, true, e)
            });
            this.addCallback(s, function (e) {
                c();
                I(t, false, m(e.code))
            });
            u("showBannerAsyncV3", r, a)
        },
        hideBannerAsyncV3: function (e, t) {
            if (!(e instanceof g)) {
                var a = m(-6);
                I(t, false, a);
                console.error(a.message);
                return
            }
            var n = this;
            var i = e.cbName;
            var r = S(i, this.HIDDEN);
            var o = S(i, this.ERROR);
            var s = function () {
                n.removeCallback(r);
                n.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, e)
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("hideBannerAsyncV3", i)
        },
        closeBannerAsyncV3: function (e, t) {
            if (!(e instanceof g)) {
                var a = m(-6);
                I(t, false, a);
                console.error(a.message);
                return
            }
            var n = this;
            var i = e.cbName;
            var r = S(i, this.CLOSED);
            var o = S(i, this.ERROR);
            var s = function () {
                n.removeCallback(r);
                n.removeCallback(o)
            };
            this.addCallback(r, function () {
                s();
                I(t, true, e)
            });
            this.addCallback(o, function (e) {
                s();
                I(t, false, m(e.code))
            });
            u("closeBannerAsyncV3", i)
        },
        getDeviceId: function () {
            return h("getDeviceId")
        },
        shareBase64: function (e, t, a, n) {
            e = e || "";
            t = t || "";
            n = n || "";
            if (typeof n === "object") {
                n = JSON.stringify(n)
            }
            if (e.indexOf("base64") === -1 && e.indexOf("path:") === -1 && !e.match(/^[\d,]+?$/)) {
                e = ""
            }
            u("shareBase64", e, t, n);
            setTimeout(function () {
                I(a, true, null)
            }, 5 * 1e3)
        },
        base64Image: function (e, t) {
            var a = function (t) {
                var a = window.document.createElement("canvas");
                a.width = t.width;
                a.height = t.height;
                var n = a.getContext("2d");
                n.drawImage(t, 0, 0, t.width, t.height);
                var i = e.substring(e.lastIndexOf(".") + 1).toLowerCase();
                return a.toDataURL("image/" + i)
            };
            var n = new Image;
            n.crossOrigin = "anonymous";
            n.src = e;
            n.onload = function () {
                t(a(n))
            }
        },
        share: function (e, t, a, n) {
            var i = this;
            i.base64Image(e, function (e) {
                return i.shareBase64(e, t, a, n)
            })
        },
        getConnectedPlayersAsync: function (e) {
            var t = "getConnectedPlayers";
            var a = this;
            var n = false;
            var i = setTimeout(function () {
                n = true;
                I(e, false, a.exception(-9));
                ug
            }, 3e4);
            if (!a.fbFriendUrl) {
                I(e, false, a.exception(-10));
                return
            }
            this.addCallback(t, function (t) {
                if (n) return;
                clearTimeout(i);
                if (t.code === 0) {
                    a.postData(a.fbFriendUrl + "/friend-fb", {
                        uid: a.player.id,
                        data: JSON.stringify(t.data)
                    }, function (t) {
                        if (n) return;
                        clearTimeout(i);
                        if (t && t.code === 0) {
                            k(e) && e(true, t.data)
                        } else if (t) {
                            k(e) && e(false, a.exception(t.code, t.data))
                        } else {
                            k(e) && e(false, a.exception(-2))
                        }
                    }, "json")
                } else {
                    I(e, false, new v("", t.code))
                }
            });
            u("getConnectedPlayers", t)
        },
        getConnectedPlayers: function (e) {
            k(e) && e([])
        },
        chooseAsync: function (e, t) {
            I(t, true, null)
        },
        updateAsync: function (e, t) {
            var a = "";
            if (typeof typeof e !== "undefined" && typeof e.image !== "undefined") {
                a = e.image
            }
            var n = "";
            if (typeof e !== "undefined" && typeof e.data !== "undefined" && typeof e.data === "object") {
                n = JSON.stringify(e.data)
            }
            u("shareBase64", a, "", n);
            setTimeout(function () {
                I(t, true, null)
            }, 5 * 1e3)
        },
        createShortcutAsync: function (e) {
            var t = "createShortcutAsync";
            this.addCallback(t, function (t) {
                if (t.code === 0) {
                    I(e, true, null)
                } else {
                    I(e, false, C(t.code))
                }
            });
            u(t)
        },
        onReady: function (e) {
            var t = "onReady";
            this.addCallback(t, function (t) {
                if (t.code === 0) {
                    I(e, true, null)
                } else {
                    I(e, false, C(t.code))
                }
            });
            u("onReady", t)
        },
        getCatalogAsync: function (e, t) {
            var a = "getCatalogAsync";
            this.addCallback(a, function (e) {
                if (e.code === 0) {
                    I(t, true, e.data)
                } else {
                    I(t, false, C(e.code))
                }
            });
            u("getCatalogAsync", e, a)
        },
        purchaseAsync: function (e, t, a) {
            var n = "purchaseAsync";
            this.addCallback(n, function (e) {
                if (e.code === 0 && e.data[0]) {
                    I(a, true, e.data[0])
                } else {
                    I(a, false, C(e.code))
                }
            });
            u("purchaseAsync", e, t, n)
        },
        getPurchasesAsync: function (e) {
            var t = "getPurchasesAsync";
            this.addCallback(t, function (t) {
                if (t.code === 0) {
                    I(e, true, t.data)
                } else {
                    I(e, false, C(t.code))
                }
            });
            u("getPurchasesAsync", t)
        },
        consumePurchaseAsync: function (e, t) {
            var a = "consumePurchaseAsync";
            this.addCallback(a, function (e) {
                if (e.code === 0) {
                    I(t, true, e.data)
                } else {
                    I(t, false, C(e.code))
                }
            });
            u("consumePurchaseAsync", e, a)
        },
        getCatalogSubsAsync: function (e, t) {
            var a = "getCatalogSubsAsync";
            this.addCallback(a, function (e) {
                if (e.code === 0) {
                    I(t, true, e.data)
                } else {
                    I(t, false, C(e.code))
                }
            });
            u("getCatalogSubsAsync", e, a)
        },
        purchaseSubsAsync: function (e, t, a) {
            var n = "purchaseSubsAsync";
            this.addCallback(n, function (e) {
                if (e.code === 0 && e.data[0]) {
                    I(a, true, e.data[0])
                } else {
                    I(a, false, C(e.code))
                }
            });
            u("purchaseSubsAsync", e, t, n)
        },
        getPurchasesSubsAsync: function (e) {
            var t = "getPurchasesSubsAsync";
            this.addCallback(t, function (t) {
                if (t.code === 0) {
                    I(e, true, t.data)
                } else {
                    I(e, false, C(t.code))
                }
            });
            u("getPurchasesSubsAsync", t)
        },
        setItem: function (e, t) {
            if (typeof e === "undefined") {
                return
            }
            if (typeof t === "undefined") {
                t = ""
            }
            u("setItem", e, t)
        },
        getItem: function (e) {
            if (typeof e === "undefined") {
                return null
            }
            var t = p("getItem", e);
            if (typeof t === "undefined") {
                t = null
            }
            return t
        },
        removeItem: function (e) {
            if (typeof e === "undefined") {
                return
            }
            u("removeItem", e)
        },
        getLocale: function () {
            return h("getLocale")
        },
        getPlatform: function () {
            return o() || s() ? "ios" : "android"
        },
        getSDKVersion: function () {
            return "1.0"
        },
        getPublish: function () {
            return "gp"
        },
        getCountryCode: function () {
            return h("getCountryCode")
        },
        getLanguageCode: function () {
            return h("getLanguageCode")
        },
        quit: function () {
            u("quit")
        },
        vibrate: function (e) {
            e = e || "";
            e += "";
            u("vibrate", e)
        },
        onPause: function (e) {
            this.addCallback("onPause", e)
        },
        onResume: function (e) {
            this.addCallback("onResume", e)
        },
        logEvent: function (e, t, a) {
            if (!e) {
                return
            }
            t = t || "";
            a = a || {};
            if (typeof a === "object") {
                a = JSON.stringify(a)
            }
            u("logEvent", e, t, a)
        },
        getPromotionAsync: function (e, t) {
            var a = this;
            if (!e) {
                k(t) && t(false, a.exception(-2));
                return
            }
            this.postData(a.dataUrl + "/promotion", {
                platform: e
            }, function (e) {
                if (e && e.code === 0) {
                    k(t) && t(true, e.data)
                } else if (e) {
                    k(t) && t(false, a.exception(e.code, e.data))
                } else {
                    k(t) && t(false, a.exception(-2))
                }
            }, "json")
        },
        openMarket: function (e, t) {
            if (!e) {
                return
            }
            var a = this;
            this.addCallback("openMarket", function (e) {
                if (e.code === 0) {
                    I(t, true, e.data)
                } else {
                    I(t, false, a.exception(-2))
                }
            });
            u("openMarket", e)
        },
        canSubscribeBotAsync: function () {},
        subscribeBotAsync: function () {},
        addNotification: function (e, t, a, n, i) {
            var r = this;
            if (!e || !t || !a || !n) {
                I(i, false, r.exception(-4));
                return
            }
            var o = "addNotification";
            var s = o + e;
            n = n + "";
            this.addCallback(s, function (e) {
                if (e.code === 0) {
                    I(i, true, null)
                } else {
                    I(i, false, r.exception(e.code))
                }
            });
            u(o, s, e, t, a, n)
        },
        removeNotification: function (e, t) {
            var a = this;
            if (!e) {
                I(t, false, a.exception(-4));
                return
            }
            var n = "removeNotification";
            var i = n + e;
            this.addCallback(i, function (e) {
                if (e.code === 0) {
                    I(t, true, null)
                } else {
                    I(t, false, a.exception(e.code))
                }
            });
            u(n, i, e)
        },
        giveMarking: function () {
            u("giveMarking")
        },
        feedback: function () {
            u("feedback")
        },
        support: function () {
            u("support")
        },
        policy: function () {
            u("policy")
        },
        openHomePage: function (e) {
            var t = this;
            var a = "openHomePage";
            this.addCallback(a, function (a) {
                if (a.code === 0) {
                    I(e, true, a.data)
                } else {
                    I(e, false, t.exception(-2))
                }
            });
            u(a, a)
        },
        joinQQGroup: function (e) {
            var t = this;
            var a = "joinQQGroup";
            this.addCallback(a, function (a) {
                if (a.code === 0) {
                    I(e, true, a.data)
                } else {
                    I(e, false, t.exception(-2))
                }
            });
            u(a, a)
        },
        clipboardText: function (e) {
            u("clipboardText", e)
        },
        sendMailTo: function (e, t) {
            t = t || "";
            u("sendMailTo", e, t)
        },
        remoteConfig: function (e) {
            var t = this;
            var a = "remoteConfig";
            t.addCallback(a, function (a) {
                if (a.code === 0) {
                    I(e, true, a.data)
                } else {
                    I(e, false, t.exception(-2))
                }
            });
            u(a, a)
        },
        crossingVideo: function () {
            u("crossingVideo")
        }
    };
    var _ = new P;
    if (i() || o()) {
        window.PLAY68_SDK = _
    } else if (r()) {
        window.PLAY68_COCOS_SDK = _
    }
    return _
}();
if (__play68_temp_sdk_obj.isCocos()) {
    module.exports = __play68_temp_sdk_obj
}(function (e, t) {
    var a = function () {
        var e = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

        function t(t) {
            if (/([^\u0000-\u00ff])/.test(t)) {
                throw new Error("INVALID_CHARACTER_ERR")
            }
            var a = 0,
                n = 0,
                i, r, o = [];
            while (a < t.length) {
                i = t.charCodeAt(a);
                r = a % 3;
                switch (r) {
                    case 0:
                        o.push(e.charAt(i >> 2));
                        break;
                    case 1:
                        o.push(e.charAt((n & 3) << 4 | i >> 4));
                        break;
                    case 2:
                        o.push(e.charAt((n & 15) << 2 | i >> 6));
                        o.push(e.charAt(i & 63));
                        break
                }
                n = i;
                a++
            }
            if (r === 0) {
                o.push(e.charAt((n & 3) << 4));
                o.push("==")
            } else if (r === 1) {
                o.push(e.charAt((n & 15) << 2));
                o.push("=")
            }
            return o.join("")
        }

        function a(t) {
            t = t.replace(/\s|=/g, "");
            var a, n = 0,
                i, r = 0,
                o = [];
            while (r < t.length) {
                a = e.indexOf(t.charAt(r));
                i = r % 4;
                switch (i) {
                    case 0:
                        break;
                    case 1:
                        o.push(String.fromCharCode(n << 2 | a >> 4));
                        break;
                    case 2:
                        o.push(String.fromCharCode((n & 15) << 4 | a >> 2));
                        break;
                    case 3:
                        o.push(String.fromCharCode((n & 3) << 6 | a));
                        break
                }
                n = a;
                r++
            }
            return o.join("")
        }
        return {
            btoa: t,
            atob: a,
            encode: t,
            decode: a
        }
    }();
    if (!e.Base64) {
        e.Base64 = a
    }
    if (!e.btoa) {
        e.btoa = a.btoa
    }
    if (!e.atob) {
        e.atob = a.atob
    }
})(window);
(function (e, t) {
    function a() {
        this.name = "fb player"
    }
    a.prototype = {
        getConnectedPlayersAsync: function () {
            return new Promise(function (e) {
                PLAY68_SDK.getConnectedPlayers(e)
            })
        }
    };

    function n() {
        this.name = "facebook";
        this.player = new a
    }
    n.prototype = {
        initializeAsync: function () {
            return new Promise(function (e) {
                PLAY68_SDK.init(e)
            })
        },
        startGameAsync: function () {
            return new Promise(function (e) {
                PLAY68_SDK.start(e)
            })
        },
        setLoadingProgress: function (e) {
            PLAY68_SDK.setLoadingProgress(e)
        },
        getSupportedAPIs: function () {
            return []
        }
    };
    if (!e.FBInstant) {
        e.FBInstant = new n
    }
})(window);